<template>
  <div>
    <vue-ellipse-progress
      :progress="percentage"
      :color="accentColor"
      :legend="false"
      empty-color="transparent"
      :empty-color-fill="emptyColorFill"
      size="140"
    >
      <span slot="legend-caption" style="font-size: 2em">{{
        formattedTime
      }}</span>
    </vue-ellipse-progress>
    {{ accent }}
  </div>
</template>

<script>
import { EventBus } from "@/plugins/bus.js";

export default {
  name: "Timer",
  data: () => ({
    timer: {},
    timePassed: 0,
  }),
  computed: {
    emptyColorFill() {
      let color1, color2;
      if (this.current_theme == "dark") {
        color1 = "#754fc1";
        color2 = "#366bfc";
      } else {
        color1 = "#FFFFFF";
        color2 = "#FFFFFF";
      }
      return {
        radial: false,
        colors: [
          {
            color: color1,
            offset: "0",
            opacity: "0.3",
          },
          {
            color: color2,
            offset: "100",
            opacity: "0.3",
          },
        ],
      };
    },
    current_theme() {
      return this.$vuetify.theme.dark ? "dark" : "light";
    },
    accentColor() {
      return this.$vuetify.theme.themes[this.current_theme].accent;
    },
    countdown() {
      return this.$store.getters["settings/timer"].timer_duration;
    },
    percentage() {
      return 100 - (100 * this.timePassed) / this.countdown;
    },
    timeLeft() {
      return this.countdown - this.timePassed;
    },
    formattedTime() {
      const timeLeft = this.timeLeft;
      const minutes = Math.floor(timeLeft / 60);
      let seconds = timeLeft % 60;
      if (seconds < 10) {
        seconds = `0${seconds}`;
      }
      return `${minutes}:${seconds}`;
    },
  },
  methods: {
    startTimer() {
      console.log(this.emptyColorFill);
      if (this.countdown > 0) {
        this.timer = setInterval(() => {
          this.timePassed += 1;
          if (this.timeLeft <= 0) {
            this.stopTimer();
          }
        }, 1000);
      }
    },
    stopTimer(force) {
      this.cleanUp();
      if (this.$store.getters["settings/timer"].timer_disconnect || force)
        EventBus.$emit("timer_finished");
    },
    cleanUp() {
      clearInterval(this.timer);
    },
    reset() {
      this.cleanUp();
      this.timePassed = 0;
    },
  },
  mounted() {
    EventBus.$on("logStarted", () => {
      this.startTimer();
    });
    EventBus.$on("resetWidgets", this.reset);
    EventBus.$on("disconnecting", this.cleanUp);
    EventBus.$on(
      "stop_timer",
      function () {
        this.stopTimer(true);
      }.bind(this)
    );
  },
  beforeDestroy() {
    this.cleanUp();
  },
};
</script>